/*
 *  Teagan Horkan
 *  CSE120
 *  Sample Array Functions
 *
 */


// Array declaration & initialization generic cases:
// <type>[] <name> = new <type>[<length>];
// <type>[] <name> = {<value1>, <value2>, ...}

// Arrays of int
int[] arrayOfNumbers1 = new int[6];
int[] arrayOfNumbers2 = {15, 12, 9, 2, 8};

// Array of char, length 7
char[] badCharArrExample = new char[7];

// Good example of array filling
char[] goodCharArrExample = {'C', 'S', 'E', ' ', '1', '2', '0'};

void setup() {
  fillWithSquares(arrayOfNumbers1);
  printIntArray(arrayOfNumbers1);
  printCharArray(goodCharArrExample);
  
  // Bad example of array filling
  badCharArrExample[0] = 'C';
  badCharArrExample[1] = 'S';
  badCharArrExample[2] = 'E';
  badCharArrExample[3] = ' ';
  badCharArrExample[4] = '1';
  badCharArrExample[5] = '2';
  badCharArrExample[6] = '0';
}

void draw() {
  // unused because we are printing to the console
  // so we don't want to print a ton of times
}

// Prints an int array in order
void printIntArray(int[] arrayParameter) {
  for (int i = 0; i < arrayParameter.length; i++) {
    println("Array element: " + arrayParameter[i]);
  }
}

// Prints a char array in order
void printCharArray(char[] arrayParameter) {
  for (int i = 0; i < arrayParameter.length; i++) {
    println("Array element: " + arrayParameter[i]);
  }
}

// Prints an int array backwards
void printIntArrayBackwards(int[] arrayParameter) {
  for (int i = arrayParameter.length - 1; i >= 0; i--) {
    println("Array element: " + arrayParameter[i]);
  }
}

// Fills an int array with the square of the index for that value
void fillWithSquares(int[] arrayParameter) {
  for (int i = 0; i < arrayParameter.length; i++) {
    arrayParameter[i] = i * i;
  }
}

// Increases every element in an int array by 1
void incrementArray(int[] arrayParameter) {
  for (int i = 0; i < arrayParameter.length; i++) {
    // arrayParameter[i] = arrayParameter[i] + 1;
    // The code below is equivalent (and shorter!)
    arrayParameter[i]++;
  }
}

// Increases every element in an int array by a given value
void incrementArrayByValue(int[] arrayParameter, int value) {
  for (int i = 0; i < arrayParameter.length; i++) {
    // arrayParameter[i] = arrayParameter[i] + value;
    // The code below is equivalent (and shorter!)
    arrayParameter[i] += value;
  }
}